;    SC 1602 ASLB-XH-HS-G
;     (  10  )
;    25 

            #INCLUDE P16F676.INC
           __CONFIG 31F4H

;==============================================
;   .
;==============================================
;-----   -----------------
C1	EQU	20H	;  
C2	EQU	21H	;  
C3	EQU	22H	;  
;-----   -----------------
R1	EQU	23H	;  .
R2	EQU	24H	;  
R3	EQU	25H	;
R4	EQU	26H	;
R5	EQU	27H	;
R6	EQU	28H	;
R7	EQU	29H	;
R8	EQU	2AH	;
R9	EQU	2BH	;
R10	EQU	2CH	;
R11	EQU	2DH	;
R12	EQU	2EH	;
R13	EQU	2FH	;
R14	EQU	30H	;
R15	EQU	31H	;
R16	EQU	32H	;
R21	EQU	33H	; .
R22	EQU	34H	; 
R23	EQU	35H	;
R24	EQU	36H	;
R25	EQU	37H	;
R26	EQU	38H	;
R27	EQU	39H	;
R28	EQU	3AH	;
R29	EQU	3BH	;
R30	EQU	3CH	;
R31	EQU	3DH	;
R32	EQU	3EH	;
R33	EQU	3FH	;
R34	EQU	40H	;
R35	EQU	41H	;
R36	EQU	42H	;
;-----   -----------------
DEST	EQU	43H	;  
TYS	EQU	44H	; 
SOT	EQU	45H	; 
DES	EQU	46H	; 
EDI	EQU	47H	; 
Sb	EQU	48H	;  
ost	EQU	49H	;    
A1	EQU	4AH	;    
A10	EQU	4BH	;    
;-----    ---------
tmp	EQU	4CH	;     
pau	EQU	4DH	;  
cnt	EQU	4EH	;     
cnt1	EQU	4FH	;  
tmp1	EQU	50H	;   convert
tmp2	EQU	51H	; 
tmp3	EQU	52H	;
I10	EQU	53H	;    ( )
I1	EQU	54H	;    ( )
E10	EQU	55H	;    
E1	EQU	56H	;    
;----    ---------------
Zr1	EQU	57H	;     ( \ )
Zr10	EQU	58H	;    
Szi	EQU	59H	;     
;*************************************************************
;****** 1. . **********************************************
;*************************************************************
        org 0
	call	init
	call	inilcd		;  
	goto	emk		;  
;**********************************************
;*** 2.    *****************
;**********************************************
init	clrwdt
	bsf	STATUS,5	;  1.
	movlw	0FF
	movwf	OSCCAL		;  
	movlw	B'00100000'	
	movwf	ADCON1		;
	movlw	B'00000001'	;
	movwf	OPTION_REG	;
	movlw	B'00000000'	;  
	movwf	INTCON		;
	clrf	PIE1		;
	movlw	B'00011111'	; RA0 - RA4 - 
	movwf	TRISA		; RA5 - 
	clrf	TRISC		; RC0-RC5 - 
	movlw	B'00000111'
	movwf	ANSEL		; RA0-RA2 -  
	clrf	VRCON		;
	clrf	PCON		;
	movlw	B'00110000'
	movwf	WPUA		;  
	clrf	IOCA		;
	bcf	STATUS,5	;  0.
	clrf	PORTC		;
	clrf	PORTA		;
	clrf	T1CON		;
	movlw	.7
	movwf	CMCON		;
;-------------------------------------------
	clrf	TMR0             ; 
	clrf	DEST
	clrf	TYS
	clrf	SOT
	clrf 	DES
	clrf 	EDI
	clrf	A10
	clrf	A1
	clrf	I10
	clrf	I1
	clrf	Zr10
	clrf	Zr1
	clrf	ost
	clrf	Szi
	clrf	E10
	movlw	.10
	movwf	E1		;    
clrs	clrf	C1		;  
	clrf	C2
	clrf 	C3
	return
;**********************************
;*** 3.  .  *******
;**********************************
inilcd
	call	pau1ms
        movlw   3
        call    LEDcom
	call	strob
        movlw   3
        call    LEDcom
	call	strob
        movlw   3          ;
	call    LEDcom
	call	strob
        movlw   10         ;
	call    LEDcom     ;
	call	strob
        movlw   06         ;
	call    LEDcom     ;
	call	strob
        movlw   01         ;
	call    LEDcom     ;
	call	strob
        movlw   28         ;
        call    LEDcom     ;
	call	strob
        movlw   28         ;
        call    LEDcom     ;
	call	strob
        movlw   0C         ;
        call    LEDcom     ;
	call	strob
	return
;*******************************************************
;*** 4.   ******************************
;*******************************************************
clrd	clrwdt			; 
	movlw	20h
	movwf	R1
	movwf	R2
	movwf	R3
	movwf	R4
	movwf	R5
	movwf	R6
	movwf	R7
	movwf	R8
	movwf	R9
	movwf	R10
	movwf	R11
	movwf	R12
	movwf	R13
	movwf	R14
	movwf	R15
	movwf	R16
	movwf	R21
	movwf	R22
	movwf	R23
	movwf	R24
	movwf	R25
	movwf	R26
	movwf	R27
	movwf	R28
	movwf	R29
	movwf	R30
	movwf	R31
	movwf	R32
	movwf	R33
	movwf	R34
	movwf	R35
	movwf	R36
	return
;*******************************************************
;** 5.    .  ************************
;*******************************************************
LEDcom
        bcf     PORTC,5		;  
        movwf   tmp		;
	swapf   tmp,W		;
 	andlw	B'00001111'	;   
        movwf   PORTC		;
        call    strob		; 
        call    pau1ms		; 
        movfw   tmp
 	andlw	B'00001111'	;   
        movwf   PORTC		;
        call    strob		; 
pau1ms
        movlw   .255		;  1 
	call	Psm
	return
;*********************************************************
;*** 6.    .  ****************************
;*********************************************************
Symb	movwf   tmp		;  
	swapf   tmp,W		;   
	andlw	B'00001111'	;   
	movwf   PORTC		;
	bsf     PORTC,5		;  
	call    strob		; 
	call    pausm		; 
	movfw   tmp		;
	andlw	B'00001111'	;   
	movwf   PORTC		;
	bsf     PORTC,5		;  
	call    strob		; 
	call	pausm		; 
	return
;*******************************************************
;*** 7.   . ************
;*******************************************************
strob	clrwdt
	nop
	bsf     PORTC,4    ;
	movlw   .25
	call	Psm
	bcf     PORTC,4    ;
	return             ;
;*************************************************
;*** 8.   R1 - R36    ***
;*************************************************
LCD 	movlw   02		;
	call    LEDcom		;
        movlw   B'10000000'	;
        call    LEDcom		;
	movlw	.16		;
	movwf	cnt		;
        movlw   R1		;
	movwf	FSR		;
	movfw	INDF		;
        call    Symb		;
	decf	cnt,1		;
	btfsc	STATUS,2	;
	goto	$+3		;
	incf	FSR,1		;
	goto	$-6		;
        movlw   B'11000000'	;
        call    LEDcom		;
	movlw	.16		;
	movwf	cnt		;
	incf	FSR,1		;
	movfw	INDF		;
        call    Symb		;
	decf	cnt,1		;
	btfss	STATUS,2	;
	goto	$-5		;
	return
;*******************************************
;*** 9.  ******************************
;*******************************************
pausm
	movlw   .10		;40 .
	addlw   -1
	btfss   STATUS,2
	goto    $-2
	return
;===========================================
pau25ms
        movlw   .25	; 25
        movwf   pau
PAUS	clrwdt
        movlw   .248
	call	Psm
        decfsz  pau,1
        goto    PAUS
        return
;==========================================
pau1s	movlw	.51
	movwf	tmp		; 
	call	pau25ms
	decfsz	tmp,1
	goto	$-2
	return
;==========================================
Psm	addlw	-1		;
	btfss	STATUS,2	;
	goto	$-2		;
	return			;
;***********************************************
;* 10.  1   SOT, DES, EDI  ***
;***********************************************
conv
	clrf	SOT		;  = 0
	clrf	DES		;  = 0
	movwf	EDI		;  = W
	addlw	-0Ah
	btfss	STATUS,0	;  
	goto	$+4		;  
	movwf	EDI		;   
	incf	DES,1		;  + 1
	goto	$-5		;  
	movf	DES,0		;
	addlw	-0Ah
	btfss	STATUS,0	;  
	goto	$+4		;  
	movwf	DES		;   
	incf	SOT,1		;  + 1
	goto	$-5		;  
	call	pers		;   
	return
;*********************************************************
;*** 11.     *****************************
;*********************************************************
chek	incf	C3,1		;   
	clrf	STATUS		;   
	movlw	.60		; W=10
	subwf	C3,0		;   W-C3
	btfsc	STATUS,0	; =0 ?
	clrf	C3		;     6
	btfsc	STATUS,0
	incf	C2,1		; 5 + 1
	movlw	.60		; W=10
	subwf	C2,0		;   W-C3
	btfsc	STATUS,0	; =0 ?
	clrf	C2		;     6
	btfsc	STATUS,0
	incf	C1,1		; 5 + 1
	movlw	.24		; W=10
	subwf	C1,0		;   W-C3
	btfsc	STATUS,0	; =0 ?
	clrf	C1		;     6
	return
;*******************************************************
;*** 12.     **********
;*******************************************************
outA	clrwdt
	movlw	49		;  " I "
	movwf	R30
	movlw	3D		;  " = "
	movwf	R31
	movf	SOT,W	;   ()
	movwf	R32
	movlw	2C		;  " , "
	movwf	R33
	movf	DES,W	; 	 ()
	movwf	R34
	movf	EDI,W	;  ()
	movwf	R35
	movlw	41		; " A "
	movwf	R36
	return
;-----------------------------------------------
outU	clrwdt
	movlw	56		;  " U "
	movwf	R10
	movlw	3D		;  " = "
	movwf	R11
	movf	SOT,0		; 
	movwf	R12		; 
	movf	DES,0		; 
	movwf	R13		; 
	movlw	2C		;  " , "
	movwf	R14		; 
	movf	EDI,0		; 
	movwf	R15		; 
	movlw	76h		;  " v "
	movwf	R16
	return
;-----------------------------------------------------
time	clrwdt
	movf	C1,W		;  
	call	conv		; 
	movf	DES,0		;  -  R1
	movwf	R1
	movf	EDI,0		;  -  R2
	movwf	R2
	movlw	3Ah		; ":"
	movwf	R3
	movf	C2,W		;  
	call	conv		; 
	movf	DES,0		;  -  R4
	movwf	R4
	movf	EDI,0		;  -  R5
	movwf	R5
	movlw	3Ah		; ":"
	movwf	R6
	movf	C3,W		;  
	call	conv		; 
	movf	DES,0		;  -  R7
	movwf	R7
	movf	EDI,0		;  -  R8
	movwf	R8
	return
;***************************************************************
;    8-     
;    A1 ( .) A10 (.)
;***************************************************************
convert	clrwdt
	clrf	DEST		; 
	clrf	TYS		;
	clrf	SOT		;
	clrf	DES		;
	clrf	EDI		;
;--    -------------------
	movf	A1,0
	movwf	EDI
	addlw	-0Ah
	btfss	STATUS,0	;  ,
	goto	$+4		;   
	movwf	EDI		;   
	incf	DES,1		;  + 1
	goto	$-5		;  
	movf	DES,0		;
	movwf	tmp1		;
	addlw	-0Ah
	btfss	STATUS,0	;  ,
	goto	$+4		;    
	movwf	DES		;   
	incf	SOT,1		;  + 1
	goto	$-5		;  
;--    ----------------------
	clrwdt
	movf	A10,0		;  t10
	movwf	tmp1		; 
next1	clrw			;  256 10 
	subwf	tmp1,0		;    
	btfsc	STATUS,Z	;  =0
	return			;   
	movlw	.6
	addwf	EDI
	movlw	.10		; W=10
	subwf	EDI,0		;   EDI - W
	btfsc	STATUS,C	; EDI>10 ?
	movwf	EDI		;    W ->EDI
	btfsc	STATUS,C
	incf	DES,1
	movlw	.5
	addwf	DES		; 
	movlw	.10		; W=10
	subwf	DES,0		;   DES - W 
	btfsc	STATUS,C	; DES>10 ?
	movwf	DES		;    W -> DES
	btfsc	STATUS,C
	incf	SOT,1
	movlw	.2		; 
	addwf	SOT
	movlw	.10		; W=10
	subwf	SOT,0		;   SOT - W 
	btfsc	STATUS,C	; SOT>10 ?
	movwf	SOT		;    W -> SOT
	btfsc	STATUS,C
	incf	TYS,1
	movlw	.10		; W=10
	subwf	TYS,0		;   TYS - W 
	btfsc	STATUS,C	; TYS>10 ?
	movwf	TYS		;    W -> TYS
	btfsc	STATUS,C
	incf	DEST,1
	decf	tmp1,1
	goto    next1
;*********************************************************
; 13. -       ---------
;------------    --------------------
;*********************************************************
Dig	clrw			;
	subwf	DEST,0		;    = 0 ?
	btfss	STATUS,Z	;
	goto	digit1		;   
	movlw	20
	movwf	DEST
	clrw			;
	subwf	TYS,0		;
	btfss	STATUS,2	;
	goto	digit2		; 
	movlw	20
	movwf	TYS
	clrw			;
	subwf	SOT,0		;
	btfss	STATUS,2	;
	goto	digit3		; 
	movlw	20
	movwf	SOT
	goto	digit4
digit1	movf	DEST,0		; 
	addlw	30
	movwf	DEST
digit2	movf	TYS,0		;
	addlw	30
	movwf	TYS
digit3	movf	SOT,0		;
	addlw	30
	movwf	SOT
digit4	movf	DES,0		;
	addlw	30
	movwf	DES
	movf	EDI,0		;
	addlw	30
	movwf	EDI
	return
;************************************************
;*** 14.     ******************************
;************************************************
zar0	clrwdt
	call	clrd		;  
;-----   ------------------------------
	call	time		;  
	movf	Zr10,0		;  
	movwf	A10		; 
	movf	Zr1,0		;  
	movwf	A1
	call	convert
	call	Dig		;   
	movf	TYS,0		; 
	movwf	R21
	movf	SOT,0		; 
	movwf	R22
	movf	DES,0		; 
	movwf	R23
	movlw	2C		;  " , "
	movwf	R24		; 
	movf	EDI,0		; 
	movwf	R25
	call	mesem		; "A/"
;-----   ------------------------------
	call	izmI		;   
	call	conv		;  
	call	nozr		;   
	call	outA		;   
	call	vrzar		;  ,  
;----------------------------------------------------------
	call	izmU		;  
	call	conv		; 
	call	nozr		;   
	call	outU		;  
;------------------------------------------------------------
	call	LCD		;   
	call	pau1s		;  
	movlw	.125		;  
	call	Psm		;  (1-255)
	btfss	PORTA,4		;   
	goto	emk		;   
	goto	chek1		;  
;-----------------------------------------------------------
vrzar	clrwdt			;  
	movlw	2		; 
	subwf	A1,0		; 
	btfss	STATUS,C	;    < 2 mA
	return			;   
	call	chek		;  -  
	call	rasch		;   
	return
;***************************************************
;----     ---------------------------
pers	movf	SOT,0
	addlw	30h
	movwf	SOT
	movf	DES,0
	addlw	30h
	movwf	DES
	movf	EDI,0
	addlw	30h
	movwf	EDI
	return
;----     -----------------------
nozer	movlw	30h
	subwf	SOT,0
	btfss	STATUS,Z
	return
	movlw	020h
	movwf	SOT
	movlw	30h
	subwf	DES,0
	btfss	STATUS,Z
	return
	movlw	020h
	movwf	DES
	return
nozr	movlw	30h
	subwf	SOT,0
	btfss	STATUS,Z
	return
	movlw	020h
	movwf	SOT
	return
;******************************************************
; 15.  -  (  ).
;******************************************************
izmI	clrwdt			;  
	clrf	A1
	movlw	.255		;  
	movwf	pau		; 
        movlw	B'11000001'	;   RA1
        movwf	ADCON0		;  RA0,  
izm1	movlw	15		;   88 
	call	Psm		;  
	call	izmer
;---------------------------------------------------------
	subwf	A1,0		;  A1 - W = W
	btfss	STATUS,C	;  A1 > W
	call	rez3		;   A1
;-------------------------------------------------------
	decfsz	pau		; 255  
	goto	izm1		; 
	movf	A1,0		;   W
	return			;   
;------------------------------------------------------
rez3	movf	tmp3,0		; tmp3 -> W
	movwf	A1
	return
;=========================================================
izmU	clrwdt			; 
	movlw	.255		;  
	movwf	pau		; 
	movwf	A1
        movlw	B'10001001'	;   Vdd
        movwf	ADCON0		;  RA2,  
izm2	movlw	15
	call	Psm
	call	izmer
;---------------------------------------------------------
	subwf	A1,0		;  A1 - W = W
	btfsc	STATUS,C	;  A1 < W
	call	rez3		;  W  A1
;-------------------------------------------------------
	decfsz	pau		; 255  
	goto	izm2		; 
	movf	A1,0		;   W
	return			;   
;=====================================================
izmer	bsf	ADCON0,1	;  
	nop
	nop
        btfsc	ADCON0,1	;  
        goto	$-1          	;
	bsf	STATUS,5	;  1.
	movf	ADRESL,0	;   -  W
	bcf	STATUS,5	;   0.
	movwf	tmp3
	return
;-----------------------------------------------
mesem	movlw	41		; " A "
	movwf	R26
	movlw	02F		; " \ "
	movwf	R27
	movlw	0C0		; "  "
	movwf	R28
	return
;************************************************************
;** 16.    ***************************
;************************************************************
;===========================================================
;== 1.      1   ==========
;===========================================================
rasch	clrwdt
	incf	A10,1
	clrf	tmp1
	movf	A1,0		;   
	addwf	Szi,0		; +   
	btfsc	STATUS,0	;  
	incf	A10		;    
	movwf	A1		; W = I1
;-----   --------------------------------------
del2	addlw	-3Ch		;     60
	btfss	STATUS,0	;  ,
	goto	$+4		;   
	incf	tmp1,1		; 
	goto	$-4		;  
	movwf	tmp1		;   cnt1
;-----------------------------------------------------------
	decf	A10,1		; A10 - 1
	btfss	STATUS,Z	;  
	goto	del12		;  
;-----------------------------------------------------------
	addlw	3Ch
	movwf	Szi		;  
	goto	Sum
;===========================================================
del12	incf	tmp1,1		; 
	goto	del2
;============================================================
Sum	movf	tmp1,0
	addwf	I1,1
	btfsc	STATUS,0	;  
	incf	I10,1
;-----------------------------------------------------------
	clrw
	subwf	C3,0
	btfss	STATUS,Z	;    = 0
	return			; 
;===========================================================
;== 2.      60 -------------------
;===========================================================
Del0	incf	I10,1
	clrf	tmp1
	movf	I1,0		;   
	addwf	ost,0		; +   
	btfsc	STATUS,0	;  
	incf	I10,1		;    
	movwf	I1		; W = I1
;-----   --------------------------------------
del	addlw	-3Ch		;     60
	btfss	STATUS,0	;  ,
	goto	$+4		;   
	incf	tmp1,1		; 
	goto	$-4		;  
	movwf	tmp1		;   tmp1
;-----------------------------------------------------------
	decf	I10,1		; I10 - 1
	btfss	STATUS,Z	;  
	goto	del11		;  
;-----------------------------------------------------------
	addlw	3Ch
	movwf	ost		;  
;--------------------------------------------------
	clrf	I10
	clrf	I1
;===========================================================
;== 3.   ----------------------------------
;===========================================================
	movf	tmp1,0
	addwf	Zr1,1		; Zr1 + tmp1
	btfsc	STATUS,C	;  
	incf	Zr10,1		;  Zr10
	return
;============================================================
del11	incf	tmp1,1		; 
	goto	del
;**************************************************************
;** 17.   ***********************************
;**************************************************************
emk	movlw	5		; 5  
	movwf	tmp2		;
;--------------------------------------
emk1	clrwdt
	call	emkout		;   
;-----------------------------------------------------------
	call	pau1s		; 
;-----------------------------------------------------------
	bsf	PORTA,5		;  
	btfss	PORTA,4		;   
	call	plus		; + 50 /
	decfsz	tmp2,1
	goto	emk1
	goto	zar0		;   
;********************************************************
emkout	call	clrd		;   
	movlw	0A2h		; 
	movwf	R1
	movlw	0BC		; 
	movwf	R2
	movlw	0BA		; 
	movwf	R3
	movlw	06F		; 
	movwf	R4
	movlw	063		; 
	movwf	R5
	movlw	0BF		; 
	movwf	R6
	movlw	0C4		; 
	movwf	R7
	movlw	061		; 
	movwf	R9
	movlw	0BA		; 
	movwf	R10
	movlw	0BA		; 
	movwf	R11
	movlw	79h		; 
	movwf	R12
	movlw	0BC		; 
	movwf	R13
	movlw	0D0		; .
	movwf	R14

	movf	E1,W		;   
	movwf	A1
	movf	E10,W		; 
	movwf	A10
	call	convert		; 
	call	Dig		;    
	movf	TYS,0		;  -  R24
	movwf	R24
	movf	SOT,0		;  -  R25
	movwf	R25
	movf	DES,0		;  -  R26
	movwf	R26
	movlw	2C		;  " , "
	movwf	R27		; 
	movf	EDI,0		;  -  R27
	movwf	R28

	movlw	41		; " A "
	movwf	R30
	movlw	02F		; " \ "
	movwf	R31
	movlw	0C0		; "  "
	movwf	R32
	call	LCD		;   
	return
;=============================================================
plus	clrwdt
	movlw	5
	movwf	tmp2		; tmp2 = 5
	movf	E1,0
	addlw	5		; +0,5 
	btfsc	STATUS,0	;  ,
	incf	E10,1
	movwf	E1
;-----   ---------------------------
	movlw	3		;  
	subwf	E10,0		; 95 
	btfss	STATUS,Z	; (3B6h)
	return
	movlw	0B6		; 
	subwf	E1,0		; 
	btfss	STATUS,0	; 
	return
	movlw	0		;  ,
	movwf	E10		; 
	movlw	.10		;  1 
	movwf	E1
	return
;**************************************************************
;** 18.     **************************
;**************************************************************
chek1	clrwdt		; 
;============     ======================
	movf	E10,0		;  
	subwf	Zr10,0		;   
	btfss	STATUS,Z	;   
	goto	zar0		; 
	movf	E1,0		;  
	subwf	Zr1,0		;   
	btfss	STATUS,C	;  
	goto	zar0		; 
	nop			; ,  

;==      ==========================================
Endzar	clrwdt
	call	clrd		;   
	movlw	0A4h		; 
	movwf	R4
	movlw	061		; 
	movwf	R5
	movlw	070		; 
	movwf	R6
	movlw	0C7		; 
	movwf	R7
	movlw	0B6		; 
	movwf	R8
	movlw	065		; 
	movwf	R9
	movlw	0BD		; 
	movwf	R10
	movlw	06F		; 
	movwf	R11
	movlw	020		; 
	movwf	R12
	movlw	021		; !
	movwf	R13
;----------------------------------
	call	izmU		;  U 
	call	conv		;  
	call	nozr		;   
	movlw	56		;  " U "
	movwf	R21
	movlw	3D		;  " = "
	movwf	R22
	movf	SOT,0		; 
	movwf	R23		; 
	movf	DES,0		; 
	movwf	R24		; 
	movlw	2C		;  " , "
	movwf	R25		; 
	movf	EDI,0		; 
	movwf	R26		; 
	movlw	76h		;  " v "
	movwf	R27
;----------------------------------------------
	movf	Zr1,W		;   
	movwf	A1
	movf	Zr10,W		; 
	movwf	A10
	call	convert		; 
	call	Dig		;    
	movf	TYS,0		;  ()
	movwf	R29
	movf	SOT,0		;  ()
	movwf	R30
	movlw	2C		;  " , "
	movwf	R31
	movf	DES,0		;  ()
	movwf	R32		; 
	movf	EDI,0		;  ()
	movwf	R33
	movlw	41		; " A "
	movwf	R34
	movlw	02F		; " \ "
	movwf	R35
	movlw	0C0		; "  "
	movwf	R36
	call	pau1s		; 991.776ms
	call	LCD		;   
	bcf	PORTA,5		;  
	btfss	PORTA,4		;   
	goto	emk		;  
	goto	Endzar		;
;************************************************************
	END

